SystemOrganization addCategory: #'JiffyCard-Core'!

ALApplication subclass: #JiffyCardApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JiffyCardApplication methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2017 07:22'!
initializeLocator
	locator 
		at: ALPath root 
		put: JCDeckOne new asResource
		
	
	" (JCMessage new message: 'The Ghost In The Machine')"! !

ALComponentResource subclass: #JCHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !

Object subclass: #JCPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCPresenter subclass: #JCComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCComponent subclass: #JCCard
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner

	^ owner! !

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner: anObject

	owner := anObject! !

JCCard subclass: #JCCounterExample
	instanceVariableNames: 'count embed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCounterExample methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:44'!
count

	^ count! !

!JCCounterExample methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:44'!
count: anObject

	count := anObject! !

!JCCounterExample methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:44'!
embed

	^ embed! !

!JCCounterExample methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:44'!
embed: anObject

	embed := anObject! !

!JCCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:16'!
initialize
	super initialize.
	embed := JCHelloWorld new owner: self
	! !

!JCCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:18'!
renderContentOn: html
	html br. 
	html a callback: [owner call: JCFormExample new]; with: 'Checkout'.
	html div id: 'chico'; with: embed! !

JCCard subclass: #JCFormExample
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
initialize
	integer := 0! !

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
renderContentOn: html
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			callback: [:str | integer := str asNumber];
			with: [].
		html text: integer asWords]! !

!JCFormExample methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
renderStyleOn: html
	html style: 'input {margin-right: 20px}'! !

JCCard subclass: #JCHelloMars
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCHelloMars class
	instanceVariableNames: 'cart'!

JCHelloMars class
	instanceVariableNames: 'cart'!

!JCHelloMars class methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:37'!
cart

	^ cart! !

!JCHelloMars class methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:37'!
cart: anObject

	cart := anObject! !

!JCHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:37'!
addToCart
	|item|
	item := WAStoreInventory default allItems first. 
	JCHelloMars cart add: item! !

!JCHelloMars methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:10'!
cart

	^ cart! !

!JCHelloMars methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:10'!
cart: anObject

	cart := anObject! !

!JCHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:41'!
initialize
	JCHelloMars cart: WAStoreCart new! !

!JCHelloMars methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:38'!
renderContentOn: html
	html p: 'Hello Mars'.
	(JCHelloMars cart hasItems) ifTrue: [html p: JCHelloMars cart countsAndItems first key printString].
	html a callback: [ self addToCart ]; with: 'Add'.
	html br. 
	html a callback: [ self answer ]; with: 'Return'! !

JCCard subclass: #JCHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHelloWorld methodsFor: 'as yet unclassified' stamp: 'chc 9/29/2017 08:20'!
renderContentOn: html
	html p: 'Welcome to the sushiNet online store'.
	html p: 'This is a sample Altitude application'.
	html p: 'Press the Browse button to choose sushi such as saba, tuna or mako'.
	html a callback: [ self call: JCHelloMars new ]; with: 'Browse'! !

!JCComponent methodsFor: 'decorations' stamp: 'chc 6/30/2017 09:27'!
addDecoration: newDecoration
	| dec |
	dec _ self decoration.
	newDecoration next: dec.
	self decoration: newDecoration! !

!JCComponent methodsFor: 'call/answer' stamp: 'chc 7/12/2017 05:46'!
answer 
	self owner removeDecoration! !

!JCComponent methodsFor: 'call/answer' stamp: 'chc 7/6/2017 07:41'!
call: anObject
	|decoration|
	anObject owner: self.
	decoration := JCDelegation new delegate: anObject. 
	self addDecoration: decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration
	^ decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration: anObject
	decoration := anObject! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:45'!
initialize
	decoration := self.
	! !

!JCComponent methodsFor: 'decorations' stamp: 'chc 6/30/2017 09:27'!
removeDecoration
	| owner |
	owner _ self decoration next.
	self decoration: owner! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 7/11/2017 07:31'!
renderOn: anObject
	(decoration isNil) 
		ifTrue: [self renderContentOn: anObject]
		ifFalse: [decoration renderContentOn: anObject]! !

JCComponent subclass: #JCDeck
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeck methodsFor: 'converting' stamp: 'chc 6/29/2017 07:08'!
asResource
	^ JCHtmlResource component: self! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 9/20/2017 09:05'!
initialize
	self call: self firstCard! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 6/29/2017 07:08'!
renderBodyOn: html
	html div
		with: [decoration renderOn: html]! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 6/29/2017 07:08'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'JiffyCard'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}'].
	html body: [ self renderBodyOn: html ] ]! !

JCDeck subclass: #JCDeckOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeckOne methodsFor: 'as yet unclassified' stamp: 'chc 9/20/2017 09:04'!
firstCard
 	^JCCounterExample new
	   ! !

JCPresenter subclass: #JCDecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next

	^ next! !

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next: anObject

	next := anObject! !

!JCDecoration methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:10'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCDecoration subclass: #JCDelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDelegation commentStamp: 'chc 5/30/2017 13:31' prior: 0!
This is a different kind of decoration. Instead of adding content or a window, which will pass on to the next decoration or the owner in the #next ivar. There is a component in the delegate ivar that replaces the original owner component. When this decoration is removed the original owner re-renders. 

It needs to go one step further. The delegate needs to be passed a self delegate reference (see Kent Beck "Smalltalk Best Practices") so that the component can have an anchor that can reach this decoration to send #remove. !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate

	^ delegate! !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate: anObject

	delegate := anObject! !

!JCDelegation methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:21'!
renderContentOn: html 
	html render: delegate! !

!JCPresenter methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:51'!
renderOn: html
	"( self respondsTo: #decoration)
		ifTrue: [  self decoration renderContentOn: html   ]
		ifFalse: [ " self renderContentOn: html   " ]"! !
